<%@ page language="java" contentType="text/html;charset=utf-8" %>
<%@ page import="org.apache.struts.action.Action"%>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/struts-logic.tld" prefix="logic" %>
<%@ taglib uri="/WEB-INF/sj.tld" prefix="sj" %>

<html:html locale="true">
<%@ include file="../common/begin.jsp" %>

<body class="content">
<sj:titleContent usingWhere="true" tomThumb="true"/>
<sj:tabs usingWhere="true" heightTab="20">
  <sj:tab forward="ActionEditDeploy"><bean:message key="tab.deployment"/></sj:tab>
  <sj:tab forward="ActionListDatasources"><bean:message key="tab.resource.datasources"/></sj:tab>
  <logic:equal name="datasourcePropertiesForm" property="create" value="true">
    <sj:tab forward="ActionEditDatasourceProperties">
      <bean:message key="tab.resource.datasource.properties.create"/>
    </sj:tab>
  </logic:equal>
  <logic:equal name="datasourcePropertiesForm" property="create" value="false">
    <sj:tab forward="ActionEditDatasourceProperties">
      <bean:message key="tab.resource.datasource.properties"/>
    </sj:tab>
  </logic:equal>
  <sj:tab forward="none" selected="true"><bean:message key="tab.resource.datasource.confirm"/></sj:tab>
  <sj:panel>
    <sj:jonasgrid>
      <sj:jgRowTitle>
        <sj:jgColTitle><bean:message key="title.resource.datasource.properties.name"/></sj:jgColTitle>
      </sj:jgRowTitle>
    </sj:jonasgrid>
    <sj:jonasgrid>
      <sj:gridrow>
        <sj:jgName><bean:message key="label.resource.datasource.properties.name"/></sj:jgName>
        <sj:gridcol valign="top"><bean:write name="datasourcePropertiesForm" property="name"/></sj:gridcol>
      </sj:gridrow>
    </sj:jonasgrid>
    <sj:jonasgrid>
      <sj:jgRowTitle>
        <sj:jgColTitle><bean:message key="title.resource.datasource.properties.datasource"/></sj:jgColTitle>
      </sj:jgRowTitle>
    </sj:jonasgrid>
    <sj:jonasgrid>
      <sj:gridrow>
        <sj:jgName><bean:message key="label.resource.datasource.properties.datasourceName"/></sj:jgName>
        <sj:gridcol valign="top"><bean:write name="datasourcePropertiesForm" property="datasourceName"/></sj:gridcol>
      </sj:gridrow>
      <sj:gridrow>
        <sj:jgName><bean:message key="label.resource.datasource.properties.datasourceDescription"/></sj:jgName>
        <sj:gridcol valign="top"><bean:write name="datasourcePropertiesForm" property="datasourceDescription"/></sj:gridcol>
      </sj:gridrow>
      <sj:gridrow>
        <sj:jgName><bean:message key="label.resource.datasource.properties.datasourceUrl"/></sj:jgName>
        <sj:gridcol valign="top"><bean:write name="datasourcePropertiesForm" property="datasourceUrl"/></sj:gridcol>
      </sj:gridrow>
      <sj:gridrow>
        <sj:jgName><bean:message key="label.resource.datasource.properties.datasourceClassname"/></sj:jgName>
        <sj:gridcol valign="top"><bean:write name="datasourcePropertiesForm" property="datasourceClassname"/></sj:gridcol>
      </sj:gridrow>
      <sj:gridrow>
        <sj:jgName><bean:message key="label.resource.datasource.properties.datasourceUsername"/></sj:jgName>
        <sj:gridcol valign="top"><bean:write name="datasourcePropertiesForm" property="datasourceUsername"/></sj:gridcol>
      </sj:gridrow>
      <sj:gridrow>
        <sj:jgName><bean:message key="label.resource.datasource.properties.datasourcePassword"/></sj:jgName>
        <sj:gridcol valign="top"><bean:write name="datasourcePropertiesForm" property="datasourcePassword"/></sj:gridcol>
      </sj:gridrow>
      <sj:gridrow>
        <sj:jgName><bean:message key="label.resource.datasource.properties.datasourceFactory"/></sj:jgName>
        <sj:gridcol valign="top"><bean:write name="datasourcePropertiesForm" property="datasourceFactory"/></sj:gridcol>
      </sj:gridrow>
      <sj:gridrow>
        <sj:jgName><bean:message key="label.resource.datasource.properties.datasourceMapper"/></sj:jgName>
        <sj:gridcol valign="top"><bean:write name="datasourcePropertiesForm" property="datasourceMapper"/></sj:gridcol>
      </sj:gridrow>
    </sj:jonasgrid>
    <sj:jonasgrid>
      <sj:jgRowTitle>
        <sj:jgColTitle><bean:message key="title.resource.datasource.properties.jdbc"/></sj:jgColTitle>
      </sj:jgRowTitle>
    </sj:jonasgrid>
    <sj:jonasgrid>
      <sj:gridrow>
        <sj:jgName><bean:message key="label.resource.datasource.properties.jdbcConnmaxage"/></sj:jgName>
        <sj:gridcol valign="top"><bean:write name="datasourcePropertiesForm" property="jdbcConnmaxage"/></sj:gridcol>
      </sj:gridrow>
      <sj:gridrow>
        <sj:jgName><bean:message key="label.resource.datasource.properties.jdbcConnchecklevel"/></sj:jgName>
        <sj:gridcol valign="top"><bean:write name="datasourcePropertiesForm" property="jdbcConnchecklevel"/></sj:gridcol>
      </sj:gridrow>
      <sj:gridrow>
        <sj:jgName><bean:message key="label.resource.datasource.properties.jdbcConnteststmt"/></sj:jgName>
        <sj:gridcol valign="top"><bean:write name="datasourcePropertiesForm" property="jdbcConnteststmt"/></sj:gridcol>
      </sj:gridrow>
      <sj:gridrow>
        <sj:jgName><bean:message key="label.resource.datasource.properties.jdbcMinconpool"/></sj:jgName>
        <sj:gridcol valign="top"><bean:write name="datasourcePropertiesForm" property="jdbcMinconpool"/></sj:gridcol>
      </sj:gridrow>
      <sj:gridrow>
        <sj:jgName><bean:message key="label.resource.datasource.properties.jdbcMaxconpool"/></sj:jgName>
        <sj:gridcol valign="top"><bean:write name="datasourcePropertiesForm" property="jdbcMaxconpool"/></sj:gridcol>
      </sj:gridrow>
    </sj:jonasgrid>
    <sj:panelSeparator/>
    <sj:jonasgrid globalRowStyleClass="panel">
      <sj:gridrow>
        <sj:jgName></sj:jgName>
        <sj:gridcol>
          <sj:jonasbutton forward="ActionApplyDatasourcePropertiesConfirm">
            <bean:message key="button.confirm"/>
          </sj:jonasbutton>
        </sj:gridcol>
      </sj:gridrow>
    </sj:jonasgrid>
  </sj:panel>
</sj:tabs>

<%@ include file="../common/end.jsp" %>
</body>
</html:html>

