/**
 * This class was generated from a set of XML constraints
 *   by the Enhydra Zeus XML Data Binding Framework. All
 *   source code in this file is constructed specifically
 *   to work with other Zeus-generated classes. If you
 *   modify this file by hand, you run the risk of breaking
 *   this interoperation, as well as introducing errors in
 *   source code compilation.
 *
 * * * * * MODIFY THIS FILE AT YOUR OWN RISK * * * * *
 *
 * To find out more about the Enhydra Zeus framework, you
 *   can point your browser at <http://zeus.enhydra.org>
 *   where you can download releases, join and discuss Zeus
 *   on user and developer mailing lists, and access source
 *   code. Please report any bugs through that website.
 */
package org.objectweb.jonas_ejb.deployment.xml;

// Global Implementation Import Statements
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.io.Writer;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import org.xml.sax.EntityResolver;
import org.xml.sax.ErrorHandler;
import org.xml.sax.InputSource;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.xml.sax.XMLReader;
import org.xml.sax.ext.LexicalHandler;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLReaderFactory;

// Local Implementation Import Statements
import java.util.Iterator;
import java.util.List;
import java.util.LinkedList;

public class JonasEntityImpl extends DefaultHandler implements Cloneable, Unmarshallable, LexicalHandler, JonasEntity {

    private EjbName ejbName;
    private JndiName jndiName;
    private List jonasResourceList;
    private List jonasResourceEnvList;
    private List jonasEjbRefList;
    private List jonasServiceRefList;
    private IsModifiedMethodName isModifiedMethodName;
    private PassivationTimeout passivationTimeout;
    private Shared shared;
    private MaxCacheSize maxCacheSize;
    private MinPoolSize minPoolSize;
    private Cleanup cleanup;
    private JdbcMapping jdbcMapping;

    /** Any DOCTYPE reference/statements. */
    private String docTypeString;

    /** The encoding for the output document */
    private String outputEncoding;

    /** The current node in unmarshalling */
    private Unmarshallable zeus_currentUNode;

    /** The parent node in unmarshalling */
    private Unmarshallable zeus_parentUNode;

    /** Whether this node has been handled */
    private boolean zeus_thisNodeHandled = false;

    /** Whether a DTD exists for an unmarshal call */
    private boolean hasDTD;

    /** Whether validation is occurring */
    private boolean validate;

    /** The namespace mappings on this element */
    private Map namespaceMappings;

    /** The EntityResolver for SAX parsing to use */
    private static EntityResolver entityResolver;

    /** The ErrorHandler for SAX parsing to use */
    private static ErrorHandler errorHandler;

    private static JonasEntityImpl prototype = null;

    public static void setPrototype(JonasEntityImpl prototype) {
        JonasEntityImpl.prototype = prototype;
    }
    public static JonasEntityImpl newInstance() {
        try {
            return (prototype!=null)?(JonasEntityImpl)prototype.clone(): new JonasEntityImpl();
        } catch (CloneNotSupportedException e) {
            return null; // never
        }
    }
    public JonasEntityImpl() {
        jonasResourceList = new LinkedList();
        jonasResourceEnvList = new LinkedList();
        jonasEjbRefList = new LinkedList();
        jonasServiceRefList = new LinkedList();
        docTypeString = "";
        hasDTD = false;
        validate = false;
        namespaceMappings = new HashMap();
    }

    public EjbName getEjbName() {
        return ejbName;
    }

    public void setEjbName(EjbName ejbName) {
        this.ejbName = ejbName;
    }

    public JndiName getJndiName() {
        return jndiName;
    }

    public void setJndiName(JndiName jndiName) {
        this.jndiName = jndiName;
    }

    public List getJonasResourceList() {
        return jonasResourceList;
    }

    public void setJonasResourceList(List jonasResourceList) {
        this.jonasResourceList = jonasResourceList;
    }

    public void addJonasResource(JonasResource jonasResource) {
        jonasResourceList.add(jonasResource);
    }

    public void removeJonasResource(JonasResource jonasResource) {
        jonasResourceList.remove(jonasResource);
    }

    public List getJonasResourceEnvList() {
        return jonasResourceEnvList;
    }

    public void setJonasResourceEnvList(List jonasResourceEnvList) {
        this.jonasResourceEnvList = jonasResourceEnvList;
    }

    public void addJonasResourceEnv(JonasResourceEnv jonasResourceEnv) {
        jonasResourceEnvList.add(jonasResourceEnv);
    }

    public void removeJonasResourceEnv(JonasResourceEnv jonasResourceEnv) {
        jonasResourceEnvList.remove(jonasResourceEnv);
    }

    public List getJonasEjbRefList() {
        return jonasEjbRefList;
    }

    public void setJonasEjbRefList(List jonasEjbRefList) {
        this.jonasEjbRefList = jonasEjbRefList;
    }

    public void addJonasEjbRef(JonasEjbRef jonasEjbRef) {
        jonasEjbRefList.add(jonasEjbRef);
    }

    public void removeJonasEjbRef(JonasEjbRef jonasEjbRef) {
        jonasEjbRefList.remove(jonasEjbRef);
    }

    public List getJonasServiceRefList() {
        return jonasServiceRefList;
    }

    public void setJonasServiceRefList(List jonasServiceRefList) {
        this.jonasServiceRefList = jonasServiceRefList;
    }

    public void addJonasServiceRef(JonasServiceRef jonasServiceRef) {
        jonasServiceRefList.add(jonasServiceRef);
    }

    public void removeJonasServiceRef(JonasServiceRef jonasServiceRef) {
        jonasServiceRefList.remove(jonasServiceRef);
    }

    public IsModifiedMethodName getIsModifiedMethodName() {
        return isModifiedMethodName;
    }

    public void setIsModifiedMethodName(IsModifiedMethodName isModifiedMethodName) {
        this.isModifiedMethodName = isModifiedMethodName;
    }

    public PassivationTimeout getPassivationTimeout() {
        return passivationTimeout;
    }

    public void setPassivationTimeout(PassivationTimeout passivationTimeout) {
        this.passivationTimeout = passivationTimeout;
    }

    public Shared getShared() {
        return shared;
    }

    public void setShared(Shared shared) {
        this.shared = shared;
    }

    public MaxCacheSize getMaxCacheSize() {
        return maxCacheSize;
    }

    public void setMaxCacheSize(MaxCacheSize maxCacheSize) {
        this.maxCacheSize = maxCacheSize;
    }

    public MinPoolSize getMinPoolSize() {
        return minPoolSize;
    }

    public void setMinPoolSize(MinPoolSize minPoolSize) {
        this.minPoolSize = minPoolSize;
    }

    public Cleanup getCleanup() {
        return cleanup;
    }

    public void setCleanup(Cleanup cleanup) {
        this.cleanup = cleanup;
    }

    public JdbcMapping getJdbcMapping() {
        return jdbcMapping;
    }

    public void setJdbcMapping(JdbcMapping jdbcMapping) {
        this.jdbcMapping = jdbcMapping;
    }

    public void setDocType(String name, String publicID, String systemID) {
        try {
            startDTD(name, publicID, systemID);
        } catch (SAXException neverHappens) { }
    }

    public void setOutputEncoding(String outputEncoding) {
        this.outputEncoding = outputEncoding;
    }

    public void marshal(File file) throws IOException {
        // Delegate to the marshal(Writer) method
        marshal(new FileWriter(file));
    }

    public void marshal(OutputStream outputStream) throws IOException {
        // Delegate to the marshal(Writer) method
        marshal(new OutputStreamWriter(outputStream));
    }

    public void marshal(Writer writer) throws IOException {
        // Write out the XML declaration
        writer.write("<?xml version=\"1.0\" ");
        if (outputEncoding != null) {
            writer.write("encoding=\"");
            writer.write(outputEncoding);
            writer.write("\"?>\n\n");

        } else {
            writer.write("encoding=\"UTF-8\"?>\n\n");

        }
        // Handle DOCTYPE declaration
        writer.write(docTypeString);
        writer.write("\n");
        // Now start the recursive writing
        writeXMLRepresentation(writer, "");

        // Close up
        writer.flush();
        writer.close();
    }

    protected void writeXMLRepresentation(Writer writer,
                                          String indent)
        throws IOException {

        writer.write(indent);
        writer.write("<jonas-entity");

        // Handle namespace mappings (if needed)
        for (Iterator i = namespaceMappings.keySet().iterator(); i.hasNext(); ) {
            String prefix = (String)i.next();
            String uri = (String)namespaceMappings.get(prefix);
            writer.write(" xmlns");
            if (!prefix.trim().equals("")) {
                writer.write(":");
                writer.write(prefix);
            }
            writer.write("=\"");
            writer.write(uri);
            writer.write("\"\n        ");
        }

        // Handle attributes (if needed)
        writer.write(">");
        writer.write("\n");

        // Handle child elements
        if (ejbName != null) {
            ((EjbNameImpl)ejbName).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (jndiName != null) {
            ((JndiNameImpl)jndiName).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        for (Iterator i=jonasResourceList.iterator(); i.hasNext(); ) {
            JonasResourceImpl jonasResource = (JonasResourceImpl)i.next();
            jonasResource.writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }
        for (Iterator i=jonasResourceEnvList.iterator(); i.hasNext(); ) {
            JonasResourceEnvImpl jonasResourceEnv = (JonasResourceEnvImpl)i.next();
            jonasResourceEnv.writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }
        for (Iterator i=jonasEjbRefList.iterator(); i.hasNext(); ) {
            JonasEjbRefImpl jonasEjbRef = (JonasEjbRefImpl)i.next();
            jonasEjbRef.writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }
        for (Iterator i=jonasServiceRefList.iterator(); i.hasNext(); ) {
            JonasServiceRefImpl jonasServiceRef = (JonasServiceRefImpl)i.next();
            jonasServiceRef.writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }
        if (isModifiedMethodName != null) {
            ((IsModifiedMethodNameImpl)isModifiedMethodName).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (passivationTimeout != null) {
            ((PassivationTimeoutImpl)passivationTimeout).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (shared != null) {
            ((SharedImpl)shared).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (maxCacheSize != null) {
            ((MaxCacheSizeImpl)maxCacheSize).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (minPoolSize != null) {
            ((MinPoolSizeImpl)minPoolSize).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (cleanup != null) {
            ((CleanupImpl)cleanup).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (jdbcMapping != null) {
            ((JdbcMappingImpl)jdbcMapping).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        writer.write(indent);
        writer.write("</jonas-entity>\n");
    }

    private String escapeAttributeValue(String attributeValue) {
        String returnValue = attributeValue;
        for (int i = 0; i < returnValue.length(); i++) {
            char ch = returnValue.charAt(i);
            if (ch == '"') {
                returnValue = new StringBuffer()
                    .append(returnValue.substring(0, i))
                    .append("&quot;")
                    .append(returnValue.substring(i+1))
                    .toString();
            }
        }
        return returnValue;
    }

    private String escapeTextValue(String textValue) {
        String returnValue = textValue;
        for (int i = 0; i < returnValue.length(); i++) {
            char ch = returnValue.charAt(i);
            if (ch == '<') {
                returnValue = new StringBuffer()
                    .append(returnValue.substring(0, i))
                    .append("&lt;")
                    .append(returnValue.substring(i+1))
                    .toString();
            } else if (ch == '>') {
                returnValue = new StringBuffer()
                    .append(returnValue.substring(0, i))
                    .append("&gt;")
                    .append(returnValue.substring(i+1))
                    .toString();
            }
        }
        return returnValue;
    }

    /**
     * <p>
     *  This sets a SAX <code>EntityResolver</code> for this unmarshalling process.
     * </p>
     *
     * @param resolver the entity resolver to use.
     */
    public static void setEntityResolver(EntityResolver resolver) {
        entityResolver = resolver;
    }

    /**
     * <p>
     *  This sets a SAX <code>ErrorHandler</code> for this unmarshalling process.
     * </p>
     *
     * @param handler the entity resolver to use.
     */
    public static void setErrorHandler(ErrorHandler handler) {
        errorHandler = handler;
    }

    public static JonasEntity unmarshal(File file) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new FileReader(file));
    }

    public static JonasEntity unmarshal(File file, boolean validate) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new FileReader(file), validate);
    }

    public static JonasEntity unmarshal(InputStream inputStream) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new InputStreamReader(inputStream));
    }

    public static JonasEntity unmarshal(InputStream inputStream, boolean validate) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new InputStreamReader(inputStream), validate);
    }

    public static JonasEntity unmarshal(Reader reader) throws IOException {
        // Delegate with default validation value
        return unmarshal(reader, false);
    }

    public static JonasEntity unmarshal(Reader reader, boolean validate) throws IOException {
        JonasEntityImpl jonasEntity = JonasEntityImpl.newInstance();
        jonasEntity.setValidating(validate);
        jonasEntity.setCurrentUNode(jonasEntity);
        jonasEntity.setParentUNode(null);
        // Load the XML parser
        XMLReader parser = null;
        String parserClass = System.getProperty("org.xml.sax.driver",
            "org.apache.xerces.parsers.SAXParser");
        try {
            parser = XMLReaderFactory.createXMLReader(parserClass);

            // Set entity resolver, if needed
            if (entityResolver != null) {
                parser.setEntityResolver(entityResolver);
            }

            // Set error handler
            parser.setErrorHandler(jonasEntity);

            // Register lexical handler
            parser.setProperty("http://xml.org/sax/properties/lexical-handler", jonasEntity);

            // Register content handler
            parser.setContentHandler(jonasEntity);
        } catch (SAXException e) {
            throw new IOException("Could not load XML parser: " + 
                e.getMessage());
        }

        InputSource inputSource = new InputSource(reader);
        try {
            parser.setFeature("http://xml.org/sax/features/validation", new Boolean(validate).booleanValue());
            parser.setFeature("http://xml.org/sax/features/namespaces", true);
            parser.setFeature("http://xml.org/sax/features/namespace-prefixes", false);
            parser.parse(inputSource);
        } catch (SAXException e) {
            throw new IOException("Error parsing XML document: " + 
                e.getMessage());
        }

        // Return the resultant object
        return jonasEntity;
    }

    public Unmarshallable getParentUNode() {
        return zeus_parentUNode;
    }

    public void setParentUNode(Unmarshallable parentUNode) {
        this.zeus_parentUNode = parentUNode;
    }

    public Unmarshallable getCurrentUNode() {
        return zeus_currentUNode;
    }

    public void setCurrentUNode(Unmarshallable currentUNode) {
        this.zeus_currentUNode = currentUNode;
    }

    public void setValidating(boolean validate) {
        this.validate = validate;
    }

    public void startDocument() throws SAXException {
        // no-op
    }

    public void setDocumentLocator(Locator locator) {
        // no-op
    }

    public void startPrefixMapping(String prefix, String uri)
        throws SAXException {
        namespaceMappings.put(prefix, uri);
    }

    public void startElement(String _namespaceURI, String localName,
                             String qName, org.xml.sax.Attributes atts)
        throws SAXException {

        // Feed this to the correct ContentHandler
        Unmarshallable current = getCurrentUNode();
        if (current != this) {
            current.startElement(_namespaceURI, localName, qName, atts);
            return;
        }

        // See if we handle, or we delegate
        if ((localName.equals("jonas-entity")) && (!zeus_thisNodeHandled)) {
            // Handle ourselves
            for (int i=0, len=atts.getLength(); i<len; i++) {
                String attName= atts.getLocalName(i);
                String attValue = atts.getValue(i);
            }
            zeus_thisNodeHandled = true;
            return;
        } else {
            // Delegate handling
            if (localName.equals("ejb-name") && (ejbName==null)) {
                EjbNameImpl ejbName = EjbNameImpl.newInstance();
                current = getCurrentUNode();
                ejbName.setParentUNode(current);
                ejbName.setCurrentUNode(ejbName);
                this.setCurrentUNode(ejbName);
                ejbName.startElement(_namespaceURI, localName, qName, atts);
                // Add this value in
                this.ejbName = ejbName;
                return;
            }
            if (localName.equals("jndi-name") && (jndiName==null)) {
                JndiNameImpl jndiName = JndiNameImpl.newInstance();
                current = getCurrentUNode();
                jndiName.setParentUNode(current);
                jndiName.setCurrentUNode(jndiName);
                this.setCurrentUNode(jndiName);
                jndiName.startElement(_namespaceURI, localName, qName, atts);
                // Add this value in
                this.jndiName = jndiName;
                return;
            }
            if (localName.equals("jonas-resource")) {
                JonasResourceImpl jonasResource = JonasResourceImpl.newInstance();
                current = getCurrentUNode();
                jonasResource.setParentUNode(current);
                jonasResource.setCurrentUNode(jonasResource);
                this.setCurrentUNode(jonasResource);
                jonasResource.startElement(_namespaceURI, localName, qName, atts);
                // Add this value in
                jonasResourceList.add(jonasResource);
                return;
            }
            if (localName.equals("jonas-resource-env")) {
                JonasResourceEnvImpl jonasResourceEnv = JonasResourceEnvImpl.newInstance();
                current = getCurrentUNode();
                jonasResourceEnv.setParentUNode(current);
                jonasResourceEnv.setCurrentUNode(jonasResourceEnv);
                this.setCurrentUNode(jonasResourceEnv);
                jonasResourceEnv.startElement(_namespaceURI, localName, qName, atts);
                // Add this value in
                jonasResourceEnvList.add(jonasResourceEnv);
                return;
            }
            if (localName.equals("jonas-ejb-ref")) {
                JonasEjbRefImpl jonasEjbRef = JonasEjbRefImpl.newInstance();
                current = getCurrentUNode();
                jonasEjbRef.setParentUNode(current);
                jonasEjbRef.setCurrentUNode(jonasEjbRef);
                this.setCurrentUNode(jonasEjbRef);
                jonasEjbRef.startElement(_namespaceURI, localName, qName, atts);
                // Add this value in
                jonasEjbRefList.add(jonasEjbRef);
                return;
            }
            if (localName.equals("jonas-service-ref")) {
                JonasServiceRefImpl jonasServiceRef = JonasServiceRefImpl.newInstance();
                current = getCurrentUNode();
                jonasServiceRef.setParentUNode(current);
                jonasServiceRef.setCurrentUNode(jonasServiceRef);
                this.setCurrentUNode(jonasServiceRef);
                jonasServiceRef.startElement(_namespaceURI, localName, qName, atts);
                // Add this value in
                jonasServiceRefList.add(jonasServiceRef);
                return;
            }
            if (localName.equals("is-modified-method-name") && (isModifiedMethodName==null)) {
                IsModifiedMethodNameImpl isModifiedMethodName = IsModifiedMethodNameImpl.newInstance();
                current = getCurrentUNode();
                isModifiedMethodName.setParentUNode(current);
                isModifiedMethodName.setCurrentUNode(isModifiedMethodName);
                this.setCurrentUNode(isModifiedMethodName);
                isModifiedMethodName.startElement(_namespaceURI, localName, qName, atts);
                // Add this value in
                this.isModifiedMethodName = isModifiedMethodName;
                return;
            }
            if (localName.equals("passivation-timeout") && (passivationTimeout==null)) {
                PassivationTimeoutImpl passivationTimeout = PassivationTimeoutImpl.newInstance();
                current = getCurrentUNode();
                passivationTimeout.setParentUNode(current);
                passivationTimeout.setCurrentUNode(passivationTimeout);
                this.setCurrentUNode(passivationTimeout);
                passivationTimeout.startElement(_namespaceURI, localName, qName, atts);
                // Add this value in
                this.passivationTimeout = passivationTimeout;
                return;
            }
            if (localName.equals("shared") && (shared==null)) {
                SharedImpl shared = SharedImpl.newInstance();
                current = getCurrentUNode();
                shared.setParentUNode(current);
                shared.setCurrentUNode(shared);
                this.setCurrentUNode(shared);
                shared.startElement(_namespaceURI, localName, qName, atts);
                // Add this value in
                this.shared = shared;
                return;
            }
            if (localName.equals("max-cache-size") && (maxCacheSize==null)) {
                MaxCacheSizeImpl maxCacheSize = MaxCacheSizeImpl.newInstance();
                current = getCurrentUNode();
                maxCacheSize.setParentUNode(current);
                maxCacheSize.setCurrentUNode(maxCacheSize);
                this.setCurrentUNode(maxCacheSize);
                maxCacheSize.startElement(_namespaceURI, localName, qName, atts);
                // Add this value in
                this.maxCacheSize = maxCacheSize;
                return;
            }
            if (localName.equals("min-pool-size") && (minPoolSize==null)) {
                MinPoolSizeImpl minPoolSize = MinPoolSizeImpl.newInstance();
                current = getCurrentUNode();
                minPoolSize.setParentUNode(current);
                minPoolSize.setCurrentUNode(minPoolSize);
                this.setCurrentUNode(minPoolSize);
                minPoolSize.startElement(_namespaceURI, localName, qName, atts);
                // Add this value in
                this.minPoolSize = minPoolSize;
                return;
            }
            if (localName.equals("cleanup") && (cleanup==null)) {
                CleanupImpl cleanup = CleanupImpl.newInstance();
                current = getCurrentUNode();
                cleanup.setParentUNode(current);
                cleanup.setCurrentUNode(cleanup);
                this.setCurrentUNode(cleanup);
                cleanup.startElement(_namespaceURI, localName, qName, atts);
                // Add this value in
                this.cleanup = cleanup;
                return;
            }
            if (localName.equals("jdbc-mapping") && (jdbcMapping==null)) {
                JdbcMappingImpl jdbcMapping = JdbcMappingImpl.newInstance();
                current = getCurrentUNode();
                jdbcMapping.setParentUNode(current);
                jdbcMapping.setCurrentUNode(jdbcMapping);
                this.setCurrentUNode(jdbcMapping);
                jdbcMapping.startElement(_namespaceURI, localName, qName, atts);
                // Add this value in
                this.jdbcMapping = jdbcMapping;
                return;
            }
        }
    }

    public void endElement(String _namespaceURI, String localName,
                           String qName)
        throws SAXException {

        Unmarshallable current = getCurrentUNode();
        if (current != this) {
            current.endElement(_namespaceURI, localName, qName);
            return;
        }

        Unmarshallable parent = getCurrentUNode().getParentUNode();
        if (parent != null) {
            parent.setCurrentUNode(parent);
        }
    }

    public void characters(char[] ch, int start, int len)
        throws SAXException {

        // Feed this to the correct ContentHandler
        Unmarshallable current = getCurrentUNode();
        if (current != this) {
            current.characters(ch, start, len);
            return;
        }

        String text = new String(ch, start, len);
    }

    public void comment(char ch[], int start, int len) throws SAXException {
        // Currently no-op
    }

    public void warning(SAXParseException e) throws SAXException {
        if (errorHandler != null) {
            errorHandler.warning(e);
        }
    }

    public void error(SAXParseException e) throws SAXException {
        if ((validate) && (!hasDTD)) {
            throw new SAXException("Validation is turned on, but no DTD has been specified in the input XML document. Please supply a DTD through a DOCTYPE reference.");
        }
        if (errorHandler != null) {
            errorHandler.error(e);
        }
    }

    public void fatalError(SAXParseException e) throws SAXException {
        if ((validate) && (!hasDTD)) {
            throw new SAXException("Validation is turned on, but no DTD has been specified in the input XML document. Please supply a DTD through a DOCTYPE reference.");
        }
        if (errorHandler != null) {
            errorHandler.fatalError(e);
        }
    }

    public void startDTD(String name, String publicID, String systemID)
        throws SAXException {

        if ((name == null) || (name.equals(""))) {
            docTypeString = "";
            return;
        }

        hasDTD = true;
        StringBuffer docTypeSB = new StringBuffer();
        boolean hasPublic = false;

        docTypeSB.append("<!DOCTYPE ")
                 .append(name);

        if ((publicID != null) && (!publicID.equals(""))) {
            docTypeSB.append(" PUBLIC \"")
                     .append(publicID)
                     .append("\"");
            hasPublic = true;
        }

        if ((systemID != null) && (!systemID.equals(""))) {
            if (!hasPublic) {
                docTypeSB.append(" SYSTEM");
            }
            docTypeSB.append(" \"")
                     .append(systemID)
                     .append("\"");

        }

        docTypeSB.append(">");

        docTypeString = docTypeSB.toString();
    }

    public void endDTD() throws SAXException {
        // Currently no-op
    }

    public void startEntity(String name) throws SAXException {
        // Currently no-op
    }

    public void endEntity(String name) throws SAXException {
        // Currently no-op
    }

    public void startCDATA() throws SAXException {
        // Currently no-op
    }

    public void endCDATA() throws SAXException {
        // Currently no-op
    }

}
