/**
 * This class was generated from a set of XML constraints
 *   by the Enhydra Zeus XML Data Binding Framework. All
 *   source code in this file is constructed specifically
 *   to work with other Zeus-generated classes. If you
 *   modify this file by hand, you run the risk of breaking
 *   this interoperation, as well as introducing errors in
 *   source code compilation.
 *
 * * * * * MODIFY THIS FILE AT YOUR OWN RISK * * * * *
 *
 * To find out more about the Enhydra Zeus framework, you
 *   can point your browser at <http://zeus.enhydra.org>
 *   where you can download releases, join and discuss Zeus
 *   on user and developer mailing lists, and access source
 *   code. Please report any bugs through that website.
 */
package org.objectweb.jonas_web.deployment.xml;

// Global Interface Import Statements
import java.io.File;
import java.io.IOException;
import java.io.OutputStream;
import java.io.Writer;

// Local Interface Import Statements
import java.util.List;
import java.io.Serializable;

public interface Servlet extends Serializable {

    public static final String ZEUS_XML_NAME = "servlet";
    public static final String[] ZEUS_ATTRIBUTES = {"id"};
    public static final String[] ZEUS_ELEMENTS = {"icon", "servlet-name", "display-name", "description", "servlet-class", "jsp-file", "init-param", "load-on-startup", "run-as", "security-role-ref"};

    public Icon getIcon();

    public void setIcon(Icon icon);

    public ServletName getServletName();

    public void setServletName(ServletName servletName);

    public DisplayName getDisplayName();

    public void setDisplayName(DisplayName displayName);

    public Description getDescription();

    public void setDescription(Description description);

    public ServletClass getServletClass();

    public void setServletClass(ServletClass servletClass);

    public JspFile getJspFile();

    public void setJspFile(JspFile jspFile);

    public List getInitParamList();

    public void setInitParamList(List initParamList);

    public void addInitParam(InitParam initParam);

    public void removeInitParam(InitParam initParam);

    public LoadOnStartup getLoadOnStartup();

    public void setLoadOnStartup(LoadOnStartup loadOnStartup);

    public RunAs getRunAs();

    public void setRunAs(RunAs runAs);

    public List getSecurityRoleRefList();

    public void setSecurityRoleRefList(List securityRoleRefList);

    public void addSecurityRoleRef(SecurityRoleRef securityRoleRef);

    public void removeSecurityRoleRef(SecurityRoleRef securityRoleRef);

    public String getId();

    public void setId(String id);

    public void marshal(File file) throws IOException;

    public void marshal(OutputStream outputStream) throws IOException;

    public void marshal(Writer writer) throws IOException;

    public void setDocType(String name, String publicID, String systemID);

    public void setOutputEncoding(String outputEncoding);

}
