/**
 * This class was generated from a set of XML constraints
 *   by the Enhydra Zeus XML Data Binding Framework. All
 *   source code in this file is constructed specifically
 *   to work with other Zeus-generated classes. If you
 *   modify this file by hand, you run the risk of breaking
 *   this interoperation, as well as introducing errors in
 *   source code compilation.
 *
 * * * * * MODIFY THIS FILE AT YOUR OWN RISK * * * * *
 *
 * To find out more about the Enhydra Zeus framework, you
 *   can point your browser at <http://zeus.enhydra.org>
 *   where you can download releases, join and discuss Zeus
 *   on user and developer mailing lists, and access source
 *   code. Please report any bugs through that website.
 */
package org.objectweb.jonas_ws.deployment.xml;

// Global Interface Import Statements
import java.io.File;
import java.io.IOException;
import java.io.OutputStream;
import java.io.Writer;

// Local Interface Import Statements
import java.util.List;
import java.io.Serializable;

public interface PortComponent extends Serializable {

    public static final String ZEUS_XML_NAME = "port-component";
    public static final String[] ZEUS_ATTRIBUTES = {"id"};
    public static final String[] ZEUS_ELEMENTS = {"description", "display-name", "small-icon", "large-icon", "port-component-name", "wsdl-port", "service-endpoint-interface", "service-impl-bean", "handler"};

    public Description getDescription();

    public void setDescription(Description description);

    public DisplayName getDisplayName();

    public void setDisplayName(DisplayName displayName);

    public SmallIcon getSmallIcon();

    public void setSmallIcon(SmallIcon smallIcon);

    public LargeIcon getLargeIcon();

    public void setLargeIcon(LargeIcon largeIcon);

    public PortComponentName getPortComponentName();

    public void setPortComponentName(PortComponentName portComponentName);

    public WsdlPort getWsdlPort();

    public void setWsdlPort(WsdlPort wsdlPort);

    public ServiceEndpointInterface getServiceEndpointInterface();

    public void setServiceEndpointInterface(ServiceEndpointInterface serviceEndpointInterface);

    public ServiceImplBean getServiceImplBean();

    public void setServiceImplBean(ServiceImplBean serviceImplBean);

    public List getHandlerList();

    public void setHandlerList(List handlerList);

    public void addHandler(Handler handler);

    public void removeHandler(Handler handler);

    public String getId();

    public void setId(String id);

    public void marshal(File file) throws IOException;

    public void marshal(OutputStream outputStream) throws IOException;

    public void marshal(Writer writer) throws IOException;

    public void setDocType(String name, String publicID, String systemID);

    public void setOutputEncoding(String outputEncoding);

}
